package com.heyu.api.controller.vv;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.heyu.api.alibaba.request.mm.VvPromoterLineRequest;
import com.heyu.api.common.annotation.AppLogin;
import com.heyu.api.common.annotation.Describe;
import com.heyu.api.data.dao.vv.VvPromoterAwardLineDao;
import com.heyu.api.data.utils.R;
import com.heyu.api.utils.ISelect;
import com.heyu.api.utils.PPageUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Slf4j
@RestController
@RequestMapping("/app/promoter/award")
@AppLogin
public class AppPromoterAwardLineController {


    @Autowired
    private VvPromoterAwardLineDao vvPromoterAwardLineDao;

    /***
     * 奖励 列表
     * http://localhost:8888/app/promoter/award/list
     */
    @Describe("我的奖励列表")
    @RequestMapping("/list")
    public R list(@RequestBody VvPromoterLineRequest vvPromoterRequest) {
        PPageUtils pageUtils = PPageUtils.startPage(vvPromoterRequest.getPageNum(), vvPromoterRequest.getPageSize())
                .doSelect(new ISelect() {
                    @Override
                    public List doSelect(IPage page) {
                        return vvPromoterAwardLineDao.selectByAppCondition(page,
                                vvPromoterRequest.getPromoterBuyerId(),
                                vvPromoterRequest.getMinCreateTimestamp(),
                                vvPromoterRequest.getMaxCreateTimestamp(),
                                vvPromoterRequest.getCreateTimestampSort()
                        );
                    }
                });

        return R.ok().setData(pageUtils);
    }

}
